; OUT(Dated) cheatpart
; Semilanceata 2008
; http//sml.cpcscene.com
;
; This source code is provided for educationnal purpose only.
; If you need any help or informations about programming your
; CPC or Plus, you can get in touch on irc.neoxys.org 6667 #cpc
;
; Grim/Arkos^Semilanceata

						run skoh_boot
						
; set this switch to 1 to embed a quick build-test code
skoh_test					equ 1

						; embed 32kb picture in #8000/#FFFF
						nolist
						write direct -1,-1,&C0
						org &8000
						read "skoh.picture.8000.asm"
						org &C000
						read "skoh.picture.C000.asm"
						
						org &1000
						nolist
skoh_boot
						di
						
						if skoh_test
							; direct CRTC setup
							; (no transition)
							; will be done properly in the bootcode
							ld bc,&BC07:out (c),c
							ld bc,&BD00+35:out (c),c
							ld bc,&BC02:out (c),c
							ld bc,&BD00+50:out (c),c
							ld bc,&BC01:out (c),c
							ld bc,&BD00+63:out (c),c
							ld bc,&BC03:out (c),c
							ld bc,&BD89:out (c),c
	
							ld bc,&BC0C:out (c),c
							ld bc,&BD30:out (c),c
							ld bc,&BC0D:out (c),c
							ld bc,&BD00:out (c),c
	
							ld c,50
	iziz ld b,&F5:in a,(c):rra:jr nc,$-3:djnz $:djnz $:dec c:jr nz,iziz

						endif
						
						ld bc,&7FC4
						ld de,&1054
						out (c),d
						out (c),e
						out (c),c
						dw &71ED
						out (c),e
						ld c,&C2
						ld hl,skoh_start
						jp &4000


; ******************************************************************************

						; assemble in the extra 64kb RAM of the 6128
						write direct -1,-1,&C2
						
						org &0000
						; jumper
						ld b,&7F
						out (c),c
						jp (hl)
						
skoh_precalc_splitscreen_lut:
						ld (iy+0),h
						ld (ix+0),l
						add hl,de
						inc iy
						inc ix
						djnz skoh_precalc_splitscreen_lut
						ret
						
						org &0038
						; interrupt mode 1 vector
						ei
						ret
skoh_start
						; detect Plus machine
						ld bc,&f782
						out (c),c
						dec b
						ld c,&f
						out (c),c
						inc b
						ld a,&82
						out (c),a
						dec b
						in a,(c)
						cp c
						jr z,skoh_asic
						; adjust splitscreen h-syncho for CPC
						ld hl,&2323	; &23=OpCode for INC HL
						ld (skoh_crtc_sync),hl
skoh_asic
						
						ld sp,$
						
						; precal splitscreen offset lookup table
						ld ix,data_splitscreen_lut
						ld iy,data_splitscreen_lut+&100
						ld hl,&2000
						ld de,&0008
						ld b,&400/8
						call skoh_precalc_splitscreen_lut
						ld hl,&3000
						ld de,&0008
						ld b,&400/8
						call skoh_precalc_splitscreen_lut
						
						; display scrolltext
						ld b,156
skoh_scrolltext_init		push bc
						call skoh_scrolltext
						pop bc
						djnz skoh_scrolltext_init
						
						; initialize SKS driver
						ld de,&F256
						call &E8C0
						ei
						
						
;*******************************************************************************
;****************************** MAIN 50HZ LOOP *********************************
;*******************************************************************************
						
						
skoh_main					ld b,&F5
						in a,(c)
						rra
						jr nc,$-3
						
						; prefetch splitscreen palette (pen15 to pen3)
						ld bc,&7F0F
						ld hl,data_pal_allblack
skoh_var_pal_splitscreen		equ $-2
						out (c),c
						inc b
						outi		; pen 15
						dec c
						out (c),c
						inc b
						outi		; pen 14
						dec c
						out (c),c
						inc b
						outi		; pen 13
						dec c
						out (c),c
						inc b
						outi		; pen 12
						dec c
						out (c),c
						inc b
						outi		; pen 11
						dec c
						out (c),c
						inc b
						outi		; pen 10
						dec c
						out (c),c
						inc b
						outi		; pen 9
						dec c
						out (c),c
						inc b
						outi		; pen 8
						dec c
						out (c),c
						inc b
						outi		; pen 7
						dec c
						out (c),c
						inc b
						outi		; pen 6
						dec c
						out (c),c
						inc b
						outi		; pen 5
						dec c
						out (c),c
						inc b
						outi		; pen 4
						; save palette pointer
						ld (skoh_var_pal_splitscreen_lo),hl
						
						; setup top SML scroller palette
						ld hl,data_pal_allblack
skoh_var_smlt_pal			equ $-2
						dec c
						out (c),c
						inc b
						outi		; pen 3
						dec c
						out (c),c
						inc b
						outi		; pen 2
						dec c
						out (c),c
						inc b
						outi		; pen 1

						; scrolltext
						; 793/832 nops
						call skoh_scrollwaster
skoh_var_scrolltext_call		equ $-2

						; kill the VSync
						ld bc,&BC07	; biggest CRTC screen in the frame
						out (c),c		; is the scrolltext with a 8 CHR
						ld bc,&BD7F	; height screen
						out (c),c	
						
						; kill border
						ld bc,&BC06
						out (c),c
						ld bc,&BD7F
						out (c),c
						
						
						; 50Hz play song
						; SKS is 34 scanlines max
						call &E8C3
						

						
;[splitscreen-SML-top]----------------------------------------------------------

						; wait first interrupt after the vsync
						halt
						di
						
						; Top SML scroller
						; 24 scanlines
						ld bc,&BC04
						out (c),c
						ld bc,&BD02
						out (c),c

;---------------------------------------------------------[/splitscreen-SML-top]
						
						
;[splitraster-scroller]---------------------------------------------------------
						
						; prefetch hardware scrolltext vram offset
						ld hl,&0000
skoh_var_scrolltext_offset	equ $-2
						ld bc,&BC0C
						out (c),c
						inc b
						out (c),h
						dec b
						inc c
						out (c),c
						inc b
						out (c),l
						
						; wait C4=0 (scrolltext screen)
						ld b,7
						djnz $
skoh_crtc_sync				nop
						nop
						
						; prefetch splitraster colors in CPU registers
						ld hl,&5454
skoh_var_splitraster_ink2	equ $-1
skoh_var_splitraster_ink3	equ $-2
						ld de,&5454
skoh_var_splitraster_ink4	equ $-1
skoh_var_splitraster_ink5	equ $-2
						ld bc,&7F54
skoh_var_splitraster_ink6	equ $-2
						exx
						ld de,&5454
skoh_var_splitraster_ink9	equ $-1
skoh_var_splitraster_ink10	equ $-2



						; prefetch splitscreen palette (pen3 and pen2)
						ld hl,skoh_var_pal_splitscreen_lo
skoh_var_pal_splitscreen_lo	equ $-2
						ld bc,&7F03

						; screen mode 2
						ld a,&8E
						out (c),a

						ds 8,0

						; prefetch splitscreen palette (pen3 to pen2)
						out (c),c
						inc b
						outi		; pen 3
						dec c
						out (c),c
						inc b
						outi		; pen 2
						ld a,(hl)
						ex af,af'	; save pen 1 color

						dec c
						ld a,&54
						out (c),c
						out (c),a	; pen 1 black
								

						; Scrolltext
						; 64 scanlines
						ld bc,&BC04
						out (c),c
						ld bc,&BD07
						out (c),c


						; prefetch splitraster colors in CPU registers
						ld hl,&5454
skoh_var_splitraster_ink7	equ $-1
skoh_var_splitraster_ink8	equ $-2
						ld bc,&7F54
skoh_var_splitraster_ink11	equ $-2
						
						; set pen/paper ink to black
						; select paper/pen used by the splitraster fx
						ld a,&01
skoh_var_splitraster_pen		equ $-1
						out (c),a
						
						ld a,&54
skoh_var_splitraster_ink1	equ $-1

						exx

						; Plasma-raster
						; A,C,H,L,D,E,C',H',L',D',E'
						ld sp,skoh_splitraster_ret
						ret
						
						
						
						
						
skoh_splitraster_exit		; restore plasma raster color
						ld a,&54
						out (c),a	; set ink used by the rasters to black
						
						; setup splitscreen mode
						ld a,&8C+0
skoh_var_splitscreen_mode	equ $-1
						out (c),a
						
						; prefetch splitscreen palette (pen1)
						ld a,1
						out (c),a
						ex af,af'
						out (c),a

;--------------------------------------------------------[/splitraster-scroller]


;[splitscreen]------------------------------------------------------------------

						ld bc,&BC07
						ld de,&0C0D
						ld hl,0
skoh_var_splitscreen_offlc0	equ $-2
						out (c),d		; select R12
						inc b
						out (c),h		; write R12
						dec b
						out (c),e		; select R13
						inc b
						out (c),l		; write R13
						
						
						dec b
						ld a,2
						out (c),a		; select R2
						inc b
						ld a,10
						; wait HCC>50
						out (c),a		; R2=9
						dec a
						
						dec b
						dw &71ED		; select R0
						inc b
						; wait VLC=0 & VCC=0 (after scroller screen)
						; then start vertical splitting
				; ----------------------------------------------------------
						out (c),c		; write R0=7

						; HCC=1
						
						dec b
						out (c),a		; select R9
						inc b
						ld a,5
						out (c),a		; R9=5
						dec b
						dec a
						out (c),a		; select R4
						inc b
						dw &71ED		; R4=0
						
						dec b
						dw &71ED		; select R0
						inc b
						ld a,23
						ld hl,0
skoh_var_splitscreen_offlc1	equ $-2
						; wait VLC=5 & HCC<7
						ds 2,0
						out (c),a
						
						; VLC=5 & HCC=1
						dec b
						out (c),d		; select R12
						inc b
						out (c),h		; write R12
						dec b
						out (c),e		; select R13
						inc b
						out (c),l		; write R13
						
						dec b
						dw &71ED
						inc b
						out (c),c
						
				; ----------------------------------------------------------
						
						; VLC=0 & HCC=7
						
						ld hl,0
skoh_var_splitscreen_offlc2	equ $-2

						exx
						
						; Realtime Dynamic Hardware Deformation (2 waves)
						; HL =wav1	HL'=lut.xx	IX=
						; DE =wav2	DE'=&0C0D		IY=
						; BC =rpt.lc	BC'=&BC02		SP=
						; AF =		AF'=			I =

						ld hl,&6000
skoh_var_splitscreen_sin0_ptr	equ $-2
						ld de,&6000
skoh_var_splitscreen_sin1_ptr	equ $-2
						ld b,&7E

						exx
						
						ds 12,0
						jr skoh_splitscreen_innerloop_enter

skoh_splitscreen_innerloop
						ld a,(de)
						add a,(hl)
						inc e
						inc l
						exx
						
						ld h,data_splitscreen_lut/256
						ld l,a
						ld a,(hl)	; offset.lo
						inc h
						ld l,(hl)	; offset.hi
						ld h,a
						
						ds 7,0	; could be used for multimode?
						
skoh_splitscreen_innerloop_enter
						ld a,23
						out (c),a		; R0=23
						
						dec b
						out (c),d
						inc b
						out (c),l
						dec b
						out (c),e
						inc b
						out (c),h
						
						dec b
						dw &71ED		; select R0
						inc b
						out (c),c		; R0=7
						
						exx
						djnz skoh_splitscreen_innerloop

						; mode 1
						ld bc,&7F8D
						out (c),c

						exx
						ld a,23
						ld c,63
						ld hl,0
skoh_var_fire_offset		equ $-2
						
						exx
						; preset fire animation palette
						ld hl,data_pal_allblack
skoh_var_fire_pal			equ $-2
						ld c,&03
						out (c),c
						exx
						
						out (c),a		; R0=23
						
						dec b
						out (c),d
						inc b
						out (c),h		; R12 fire
						dec b
						out (c),e
						inc b
						out (c),l		; R13 fire
						
						dec b
						dw &71ED
						inc b
						out (c),c		; R0=63
						
						ld de,&0200+50
						dec b
						out (c),d
						inc b
						out (c),e
						
						ld de,&0907
						dec b
						out (c),d
						inc b
						out (c),e
						
						
;[splitscreen-fire-animation]---------------------------------------------------

						; 32 scanlines height
						ld de,&0403
						dec b
						out (c),d
						inc b
						out (c),e

						exx
						inc b
						; finish loading fire palette
						outi
						dec c
						out (c),c
						inc b
						outi
						dec c
						out (c),c
						inc b
						outi
						
						ld sp,&0038
						
;--------------------------------------------------[/splitscreen-fire-animation]

						; WASTE 28 SCANLINES!! AAARRG!
						ld b,28
waste28					defs 60,0
						djnz waste28

;[splitscreen-SML-bottom]-------------------------------------------------------

						; prefetch bottom SML scrollers vram offset
						ld hl,0
skoh_var_smlb_offset	equ $-2
						ld bc,&BC0C
						out (c),c
						inc b
						out (c),h
						dec b
						inc c
						out (c),c
						inc b
						out (c),l

						ld b,16
						djnz $
						
						ld hl,data_pal_allblack
skoh_var_smlb_pal		equ $-2
						ld bc,&7F03
						out (c),c
						inc b
						outi
						dec c
						out (c),c
						inc b
						outi
						dec c
						out (c),c
						inc b
						outi
						
						ld b,16
						djnz $
						
						; set vsync in 24 scanlines
						ld bc,&BC07
						out (c),c
						ld bc,&BD04
						out (c),c
						
						; Set border after the bottom SML scroller
						ld bc,&BC06
						out (c),c
						ld bc,&BD03
						out (c),c

						; 24+32 scanlines
						ld bc,&BC04
						out (c),c
						ld bc,&BD07
						out (c),c
						
;------------------------------------------------------[/splitscreen-SML-bottom]
						
						
;[splitrasters]-----------------------------------------------------------------
						
						ld hl,&3B00
skoh_var_splitraster_sin0	equ $-2

						ld de,&3400
skoh_var_splitraster_sin1	equ $-2

						ld bc,&3400
skoh_var_splitraster_sin2	equ $-2

skoh_var_splitraster_mov0	nop ;dec l
skoh_var_splitraster_mov1	nop ;dec e
skoh_var_splitraster_mov2	nop ;inc c

						ld (skoh_var_splitraster_sin0),hl
						ld (skoh_var_splitraster_sin1),de
						ld (skoh_var_splitraster_sin2),bc

						exx
						ld hl,skoh_splitraster_lut
						ld sp,skoh_splitraster_push
						
						ld b,31
skoh_splitraster_precalc_loop
						exx
						ld a,(bc)
						add a,(hl)
						ex de,hl
						add a,(hl)
						inc c
						inc e
						inc l
						exx
						ld l,a
						ld e,(hl)
						inc h
						ld d,(hl)
						push de
						exx
						
						ld a,(bc)
						add a,(hl)
						ex de,hl
						add a,(hl)
						inc c
						inc e
						inc l
						exx
						ld l,a
						ld d,(hl)
						dec h
						ld e,(hl)
						push de
						
						djnz skoh_splitraster_precalc_loop

						ld sp,&C000
;----------------------------------------------------------------[/splitrasters]

						ei

						call skoh_flipscrollers
						
						; prefetch top SML scroller vram offset
						ld hl,0
skoh_var_smlt_offset		equ $-2
						ld bc,&BC0C
						out (c),c
						inc b
						out (c),h
						dec b
						inc c
						out (c),c
						inc b
						out (c),l

						call skoh_keyframer


						; update splitscreen variables
						
						ld bc,&0000
skoh_var_splitscreen_sin0_stp	equ $-1
skoh_var_splitscreen_sin1_stp	equ $-2

						ld hl,&2080
skoh_var_splitscreen_sin0_wav	equ $-1
skoh_var_splitscreen_sin0_pos	equ $-2

						ld de,&3400
skoh_var_splitscreen_sin1_wav	equ $-1
skoh_var_splitscreen_sin1_pos	equ $-2

						ld a,l
						add a,b
						ld (skoh_var_splitscreen_sin0_pos),a
						ld l,a
						
						ld a,e
						add a,c
						ld (skoh_var_splitscreen_sin1_pos),a
						ld e,a
						
						; precalc the three first splitscreen offset						
						; lc0
						ld a,(de)
						add a,(hl)
						inc e
						inc l
						exx
						ld h,data_splitscreen_lut/256
						ld l,a
						ld e,(hl)	; offset.lo
						inc h
						ld d,(hl)	; offset.hi
						dec h
						ld (skoh_var_splitscreen_offlc0),de
						exx
						
						; lc1
						ld a,(de)
						add a,(hl)
						inc e
						inc l
						exx
						ld l,a
						ld e,(hl)	; offset.lo
						inc h
						ld d,(hl)	; offset.hi
						dec h
						ld (skoh_var_splitscreen_offlc1),de
						exx
						
						; lc2
						ld a,(de)
						add a,(hl)
						inc e
						inc l
						exx
						ld l,a
						ld d,(hl)	; offset.lo
						inc h
						ld e,(hl)	; offset.hi
						ld (skoh_var_splitscreen_offlc2),de
						exx
						
						ld (skoh_var_splitscreen_sin0_ptr),hl
						ld (skoh_var_splitscreen_sin1_ptr),de
												
						jp skoh_main
						
						
						
						
;*******************************************************************************
;******************************* Subroutines ***********************************
;*******************************************************************************
						
						
skoh_scrollwaster:			ld b,16*13
						djnz $
						ret
						
						
skoh_flipscrollers:
						ld a,0
skoh_var_fire_pos			equ $-1
skoh_var_fire_mov			inc a
						ld (skoh_var_fire_pos),a
						and %00001100
						ld h,&12
						add a,&F4
						ld l,a
						jr nc,$+3
						inc h
						ld (skoh_var_fire_offset),hl
						

						ld a,12*4-4
skoh_var_smlt_pos			equ $-1
						add a,0
skoh_var_smlt_mov			equ $-1
						jp p,$+3+2
						ld a,47
						
						cp 48
						jr c,$+2+1
						xor a
						ld (skoh_var_smlt_pos),a
						
						ld de,skoh_var_smlt_offset
						call skoh_sml_set_offset
						
						ld a,12*4-4
skoh_var_smlb_pos			equ $-1
						add a,0
skoh_var_smlb_mov			equ $-1
						jp p,$+3+2
						ld a,47
						
						cp 48
						jr c,$+2+1
						xor a
						ld (skoh_var_smlb_pos),a
						
						ld de,skoh_var_smlb_offset
						
skoh_sml_set_offset	
						add a,a
						add a,skoh_sml_lut and 255
						ld l,a
						ld h,skoh_sml_lut/256
						jr nc,$+2+1
						inc h
						
						ldi
						ldi
						ret
						
skoh_sml_lut				dw &1000,&10BD,&117A,&1237
						dw &1001,&10BE,&117B,&1238
						dw &1002,&10BF,&117C,&1239
						dw &1003,&10C0,&117D,&123A
						dw &1004,&10C1,&117E,&123B
						dw &1005,&10C2,&117F,&123C
						dw &1006,&10C3,&1180,&123D
						dw &1007,&10C4,&1181,&123E
						dw &1008,&10C5,&1182,&123F
						dw &1009,&10C6,&1183,&1240
						dw &100A,&10C7,&1184,&1241
						dw &100B,&10C8,&1185,&1242
						
						
						
						
skoh_keyframer:
						ld hl,1
skoh_var_keyframer_timer		equ $-2
						dec hl
						ld a,h
						or l
						jr z,skoh_keyframer_next_events
						ld (skoh_var_keyframer_timer),hl
						ret
						
skoh_keyframer_next_events
						ld hl,data_keyframer
skoh_var_keyframer_evtlst	equ $-2
skoh_keyframer_loop			ld de,skoh_var_keyframer_call
						ldi
						ldi
						call 0
skoh_var_keyframer_call		equ $-2
						jr skoh_keyframer_loop
						
						
						
skoh_keyframer_action_wait	ld de,skoh_var_keyframer_timer
						ldi
						ldi
						ld (skoh_var_keyframer_evtlst),hl
						pop af
						ret
						
skoh_keyframer_action_jump	ld a,(hl)
						inc hl
						ld h,(hl)
						ld l,a
						ret
						
data_keyframer
						dw skoh_keyframer_action_wait, 50*16

						dw skoh_action_sr_white
						dw skoh_keyframer_action_wait, 3
						dw skoh_action_sr_black
						dw skoh_keyframer_action_wait, 9
						dw skoh_action_sr_white
						dw skoh_keyframer_action_wait, 5
						dw skoh_action_sr_black
						dw skoh_keyframer_action_wait, 5
						dw skoh_action_sr_white
						dw skoh_keyframer_action_wait, 5
						dw skoh_action_sr_black
						dw skoh_keyframer_action_wait, 3
						dw skoh_action_sr_white
						dw skoh_keyframer_action_wait, 50*17

						dw skoh_action_sr_paper
						dw skoh_action_sr_pal_red_blue
						dw skoh_keyframer_action_wait, 50*3
						
						dw skoh_action_sr_setmov:dec l:nop:nop
						dw skoh_keyframer_action_wait, 50*3
						
						dw skoh_action_sr_black
						dw skoh_action_scroll_start
						dw skoh_action_firep, skoh_flipscroll_pal10
						dw skoh_keyframer_action_wait, 50*4
						
						dw skoh_action_sr_white
						dw skoh_keyframer_action_wait, 50*6
						
						dw skoh_action_smlbp, skoh_flipscroll_pal1
						dw skoh_keyframer_action_wait, 50*6
						
						dw skoh_action_sml_mov,&00FF
						dw skoh_keyframer_action_wait, 12*4 * 4
						dw skoh_action_sml_mov,&0001
						dw skoh_keyframer_action_wait, 12*4 * 4
						dw skoh_action_sml_mov,&00FF
						dw skoh_keyframer_action_wait, 12*4 * 4
						dw skoh_action_sml_mov,&0000
						
						dw skoh_keyframer_action_wait, 50*4
						
						dw skoh_action_smltp, skoh_flipscroll_pal1
						dw skoh_keyframer_action_wait, 50*4
						
						dw skoh_action_sml_mov,&FF00
						dw skoh_keyframer_action_wait, 12*4 * 4
						
						dw skoh_action_sml_mov,&00FF
						dw skoh_keyframer_action_wait, 12*4
						dw skoh_action_sml_mov,&FF00
						dw skoh_keyframer_action_wait, 12*4
						dw skoh_action_sml_mov,&00FF
						dw skoh_keyframer_action_wait, 12*4
						dw skoh_action_sml_mov,&FF00
						dw skoh_keyframer_action_wait, 12*4
						dw skoh_action_sml_mov,&00FF
						dw skoh_keyframer_action_wait, 12*4
						dw skoh_action_sml_mov,&0000
						dw skoh_keyframer_action_wait, 50*5
						
						
						dw skoh_action_sr_pen1
						dw skoh_action_sr_pal_blue
						dw skoh_action_sml_mov,&FF01
						dw skoh_keyframer_action_wait, 50*5
						

						dw skoh_action_ss_pal, data_pal_splitscreen1
						dw skoh_keyframer_action_wait, 50*5
data_keyframer_loop
						dw skoh_action_ss_mov,&0100
						dw skoh_action_sml_mov,&01FF
						dw skoh_keyframer_action_wait, 50*5
						
						dw skoh_action_ss_mov,&FF00
						dw skoh_action_smltp, skoh_flipscroll_pal6
						dw skoh_action_smlbp, skoh_flipscroll_pal5
						dw skoh_keyframer_action_wait, 50*5
						
						dw skoh_action_firep, skoh_flipscroll_pal10
						dw skoh_action_sr_setsin, &3B00,&3C00,&3D00
						dw skoh_keyframer_action_wait, 50*3
						
						dw skoh_action_sr_pal_pink
						dw skoh_action_sr_paper
						dw skoh_action_sr_setmov:inc l:dec e:nop
						dw skoh_action_ss_wav,&2080,&2100
						dw skoh_keyframer_action_wait, 50*5
						
						dw skoh_action_sr_pal_red
						dw skoh_action_sr_setmov:dec l:nop:inc c
						dw skoh_action_sml_mov,&FFFF
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_sml_mov,&01FF
						dw skoh_action_sr_pal_red_blue
						dw skoh_action_sr_setsin, &3B00,&3700,&3900
						dw skoh_action_sr_setmov:dec l:inc e:dec c
						dw skoh_action_firep, skoh_flipscroll_pal14
						dw skoh_keyframer_action_wait, 50*20
						
						
						dw skoh_action_sml_mov,&0101
						dw skoh_action_smltp, skoh_flipscroll_pal2
						dw skoh_action_smlbp, skoh_flipscroll_pal10
						dw skoh_action_sr_setsin, &3B00,&3A00,&3800
						dw skoh_action_ss_wav,&2080,&2300
						dw skoh_action_ss_mov,&0001
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_ss_mov,&FF01
						dw skoh_action_firep, skoh_flipscroll_pal15
						dw skoh_action_smltp, skoh_flipscroll_pal10
						dw skoh_action_smlbp, skoh_flipscroll_pal2
						dw skoh_keyframer_action_wait, 50*20
						
						dw skoh_action_sr_pen1
						dw skoh_action_sr_pal_blue_pink
						dw skoh_action_sr_setsin, &3600,&3500,&3700
						dw skoh_action_sr_setmov:inc l:nop:dec c
						dw skoh_action_ss_wav,&2080,&2500
						dw skoh_action_ss_mov,&0001
						dw skoh_action_smltp, skoh_flipscroll_pal13
						dw skoh_action_smlbp, skoh_flipscroll_pal5
						dw skoh_action_sml_mov,&0000
						dw skoh_keyframer_action_wait, 50*10
						
						dw skoh_action_sml_mov,&FF00
						dw skoh_keyframer_action_wait, 50*20
						
						dw skoh_action_sr_pal_pink
						dw skoh_action_sr_setsin, &3800,&3500,&3900
						dw skoh_action_ss_wav,&2000,&2000
						dw skoh_action_ss_mov,&0001
						dw skoh_action_sml_mov,&FF01
						dw skoh_keyframer_action_wait, 50*20
						
						dw skoh_action_smltp, skoh_flipscroll_pal10
						dw skoh_action_smlbp, skoh_flipscroll_pal1
						dw skoh_keyframer_action_wait, 50*10
						
						
						dw skoh_action_firep, skoh_flipscroll_pal14
						dw skoh_action_sr_pal_blue
						dw skoh_action_sr_setsin, &3500,&3800,&3D00
						dw skoh_action_sr_paper
						dw skoh_action_sml_mov,&01FF
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_smlbp, skoh_flipscroll_pal6
						dw skoh_action_sr_setmov:dec l:dec e:inc c
						dw skoh_action_sr_setsin, &3500,&3600,&3700
						dw skoh_action_ss_wav,&2400,&2000
						dw skoh_action_ss_mov,&0001
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_smltp, skoh_flipscroll_pal4
						dw skoh_action_smlbp, skoh_flipscroll_pal5
						dw skoh_action_sr_pal_green
						dw skoh_action_sml_mov,&FF01
						dw skoh_action_sr_setmov:inc l:dec e:dec c
						dw skoh_keyframer_action_wait, 50*30
						
						
						; all green
						dw skoh_action_sr_pal_green
						dw skoh_action_sr_setsin, &3500,&3600,&3700
						dw skoh_action_sr_setmov:nop:dec e:inc c
						dw skoh_action_smlbp, skoh_flipscroll_pal1
						dw skoh_action_smltp, skoh_flipscroll_pal1
						dw skoh_action_firep, skoh_flipscroll_pal1
						dw skoh_action_sml_mov,&0000
						dw skoh_action_ss_wav,&2510,&2000
						dw skoh_action_ss_mov,&00FF
						dw skoh_keyframer_action_wait, 50*5
						
						dw skoh_action_sml_mov,&01FF
						dw skoh_keyframer_action_wait, 50*20
						
						; all blue
						dw skoh_action_sr_pal_blue
						dw skoh_action_sr_setsin, &3900,&3700,&3800
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_smltp, skoh_flipscroll_pal3
						dw skoh_action_smlbp, skoh_flipscroll_pal3
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_firep, skoh_flipscroll_pal3
						dw skoh_action_sml_mov,&0101
						dw skoh_keyframer_action_wait, 50*30
						
						; all red
						dw skoh_action_sr_pal_red
						dw skoh_action_sr_setsin, &3C00,&3B00,&3D00
						dw skoh_action_sr_setmov:nop:inc e:dec c
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_smlbp, skoh_flipscroll_pal4
						dw skoh_action_smltp, skoh_flipscroll_pal4
						dw skoh_action_sml_mov,&FF01
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_firep, skoh_flipscroll_pal10
						dw skoh_action_ss_wav,&2800,&2000
						dw skoh_action_ss_mov,&FF01
						dw skoh_keyframer_action_wait, 50*30
						
						
						dw skoh_action_smltp, skoh_flipscroll_pal5
						dw skoh_action_sr_pal_blurp
						dw skoh_action_sr_setsin, &3D00,&3800,&3500
						dw skoh_action_sr_setmov:dec l:dec e:inc c
						dw skoh_action_firep, skoh_flipscroll_pal8
						dw skoh_action_smlbp, skoh_flipscroll_pal1
						dw skoh_keyframer_action_wait, 50*30
						
						; red/blue
						dw skoh_action_sr_pal_red_blue
						dw skoh_action_sr_setsin, &3600,&3700,&3600
						dw skoh_action_smltp, skoh_flipscroll_pal10
						dw skoh_action_smlbp, skoh_flipscroll_pal3
						dw skoh_action_firep, skoh_flipscroll_pal3
						dw skoh_action_sml_mov,&0000
						dw skoh_action_sr_pen1
						dw skoh_keyframer_action_wait, 50*5
						
						dw skoh_action_sml_mov,&FFFF
						dw skoh_keyframer_action_wait, 50*25
						
						; green/magenta
						dw skoh_action_sr_pal_green
						dw skoh_action_smltp, skoh_flipscroll_pal1
						dw skoh_action_smlbp, skoh_flipscroll_pal6
						dw skoh_action_firep, skoh_flipscroll_pal6
						dw skoh_action_sr_paper
						dw skoh_action_ss_wav,&2200,&2000
						dw skoh_action_ss_mov,&0001
						dw skoh_keyframer_action_wait, 50*30
						
						
						dw skoh_action_sml_mov,&FF01
						dw skoh_action_smltp, skoh_flipscroll_pal1
						dw skoh_action_sr_pal_red_blue
						dw skoh_action_sr_setsin, &3500,&3A00,&3D00
						dw skoh_action_firep, skoh_flipscroll_pal6
						dw skoh_action_smlbp, skoh_flipscroll_pal11
						dw skoh_action_ss_wav,&2300,&2000
						dw skoh_action_ss_mov,&0001
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_ss_mov,&01FF
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_sr_pen1
						dw skoh_action_sr_pal_pink
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_ss_wav,&2300,&2000
						dw skoh_action_ss_mov,&0001
						dw skoh_action_sml_mov,&01FF
						dw skoh_keyframer_action_wait, 50*13
						
						dw skoh_action_ss_mov,&0201
						dw skoh_keyframer_action_wait, 50*10
						
						dw skoh_action_sr_pal_red
						dw skoh_action_sr_paper
						dw skoh_action_smltp, skoh_flipscroll_pal12
						dw skoh_action_firep, skoh_flipscroll_pal10
						dw skoh_action_smlbp, skoh_flipscroll_pal12
						dw skoh_keyframer_action_wait, 50*24
						
						
						dw skoh_action_sml_mov,&FFFF
						dw skoh_action_ss_wav,&2800,&2080
						dw skoh_action_ss_mov,&0100
						dw skoh_keyframer_action_wait, 50*10
						
						
						dw skoh_action_ss_mov,&0201
						dw skoh_keyframer_action_wait, 50*24
						
						
						dw skoh_action_smltp, skoh_flipscroll_pal4
						dw skoh_action_firep, skoh_flipscroll_pal2
						dw skoh_action_smlbp, skoh_flipscroll_pal5
						dw skoh_action_sr_pal_blue_pink
						dw skoh_action_sr_pen1
						dw skoh_action_sr_setsin, &3C00,&3B00,&3D00
						dw skoh_action_sr_setmov:inc l:dec e:nop
						dw skoh_keyframer_action_wait, 50*10
						
						dw skoh_action_ss_wav,&2080,&2100
						dw skoh_action_ss_mov,&0001
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_firep, skoh_flipscroll_pal9
						dw skoh_action_sr_setmov:dec l:inc e:dec c
						dw skoh_action_ss_mov,&FF01
						dw skoh_keyframer_action_wait, 50*15
						
						
						dw skoh_action_sr_paper
						dw skoh_action_sr_pal_blurp
						dw skoh_action_sr_setsin, &3D00,&3800,&3500
						dw skoh_action_sr_setmov:dec l:nop:inc c
						dw skoh_action_sml_mov,&FF01
						dw skoh_keyframer_action_wait, 50*15
						
						dw skoh_action_smltp, skoh_flipscroll_pal2
						dw skoh_action_firep, skoh_flipscroll_pal1
						dw skoh_action_smlbp, skoh_flipscroll_pal2
						dw skoh_keyframer_action_wait, 50*15
						
						
						dw skoh_action_ss_wav,&2600,&2700
						dw skoh_action_ss_mov,&0001
						dw skoh_keyframer_action_wait, 50*20
						
						
						dw skoh_action_sr_pal_blue
						dw skoh_action_sr_pen1
						dw skoh_action_smltp, skoh_flipscroll_pal10
						dw skoh_action_firep, skoh_flipscroll_pal4
						dw skoh_action_smlbp, skoh_flipscroll_pal13
						dw skoh_action_ss_mov,&FFFE
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sml_mov,&0000
						dw skoh_action_ss_mov,&0201
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sml_mov,&FFFF
						dw skoh_action_firep, skoh_flipscroll_pal8
						dw skoh_action_sr_pal_blue_pink
						dw skoh_action_sr_paper
						dw skoh_action_sr_setsin, &3800,&3500,&3900
						dw skoh_action_sr_setmov:inc l:nop:dec c
						dw skoh_action_ss_wav,&2400,&2700
						dw skoh_action_ss_mov,&FF01
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_smltp, skoh_flipscroll_pal1
						dw skoh_action_smlbp, skoh_flipscroll_pal1
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sml_mov,&0101
						dw skoh_action_sr_pal_pink
						dw skoh_action_sr_setsin, &3C00,&3B00,&3D00
						dw skoh_action_sr_setmov:inc l:inc e:dec c
						dw skoh_action_firep, skoh_flipscroll_pal3
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sr_setmov:dec l:inc e:inc c
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sml_mov,&FF01
						dw skoh_action_smltp, skoh_flipscroll_pal5
						dw skoh_action_firep, skoh_flipscroll_pal6
						dw skoh_action_ss_wav,&2300,&2000
						dw skoh_action_ss_mov,&0001
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sr_paper
						dw skoh_action_sr_pal_blurp
						dw skoh_action_sr_setsin, &3500,&3600,&3700
						dw skoh_keyframer_action_wait, 50*20
						
						
						; pink-green-gfx-green-ping
						dw skoh_action_sml_mov,&01FF
						dw skoh_action_sr_pal_green
						dw skoh_action_sr_setsin, &3500,&3600,&3700
						dw skoh_action_smltp, skoh_flipscroll_pal13
						dw skoh_action_firep, skoh_flipscroll_pal1
						dw skoh_action_smlbp, skoh_flipscroll_pal13
						dw skoh_action_ss_mov,&FF01
						dw skoh_keyframer_action_wait, 50*40
						
						
						dw skoh_action_ss_wav,&2000,&2600
						dw skoh_action_ss_mov,&0001
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sml_mov,&0001
						dw skoh_action_sr_pal_red_blue
						dw skoh_action_sr_setsin, &3600,&3500,&3200
						dw skoh_action_sr_setmov:dec l:nop:inc c
						dw skoh_action_smltp, skoh_flipscroll_pal1
						dw skoh_action_firep, skoh_flipscroll_pal8
						dw skoh_action_smlbp, skoh_flipscroll_pal1
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sml_mov,&FF00
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sr_pal_red
						dw skoh_action_sr_setsin, &3B00,&3400,&3400
						dw skoh_action_sr_setmov:nop:nop:nop
						dw skoh_action_sml_mov,&01FF
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sr_setmov:inc l:nop:nop
						dw skoh_action_smltp, skoh_flipscroll_pal15
						dw skoh_action_firep, skoh_flipscroll_pal14
						dw skoh_action_smlbp, skoh_flipscroll_pal15
						dw skoh_keyframer_action_wait, 50*20
						
						
						dw skoh_action_sr_setsin, &3B00,&3C00,&3D00
						dw skoh_action_sml_mov,&FF01
						dw skoh_action_ss_wav,&2600,&2700
						dw skoh_action_ss_mov,&FE03
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_smltp, skoh_flipscroll_pal6
						dw skoh_action_firep, skoh_flipscroll_pal9
						dw skoh_action_smlbp, skoh_flipscroll_pal2
						dw skoh_action_sr_setmov:inc l:dec e:nop
						dw skoh_action_sml_mov,&0000
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sr_pal_pink
						dw skoh_action_sr_setsin, &3600,&3700,&3500
						dw skoh_action_sml_mov,&0101
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_smltp, skoh_flipscroll_pal1
						dw skoh_action_firep, skoh_flipscroll_pal8
						dw skoh_action_smlbp, skoh_flipscroll_pal1
						dw skoh_action_ss_wav,&2900,&2000
						dw skoh_action_ss_mov,&0001
						dw skoh_action_sml_mov,&FF01
						dw skoh_keyframer_action_wait, 50*20
						
						
						
						dw skoh_action_sr_pal_blue
						dw skoh_action_sr_setmov:dec l:nop:nop
						dw skoh_action_sml_mov,&01FF
						dw skoh_keyframer_action_wait, 50*20
						
						
						dw skoh_action_firep, skoh_flipscroll_pal14
						dw skoh_action_ss_wav,&2900,&2600
						dw skoh_action_sml_mov,&02FF
						dw skoh_keyframer_action_wait, 50*20
						
						dw skoh_action_sr_pal_blue_pink
						dw skoh_action_sr_setmov:inc l:dec e:nop
						dw skoh_action_sr_setsin, &3D00,&3A00,&3500
						dw skoh_action_smltp, skoh_flipscroll_pal5
						dw skoh_action_firep, skoh_flipscroll_pal8
						dw skoh_action_smlbp, skoh_flipscroll_pal6
						dw skoh_action_sml_mov,&0201
						dw skoh_keyframer_action_wait, 50*20
						
						
						dw skoh_action_ss_wav,&2100,&2000
						dw skoh_action_ss_mov,&FF01
						dw skoh_action_sml_mov,&FF01
						dw skoh_keyframer_action_wait, 50*20
						
						
						; wrap sequence
						dw skoh_action_sr_setsin, &3B00,&3400,&3400
						dw skoh_action_sr_setmov:nop:nop:nop
						dw skoh_action_smltp, data_pal_allblack
						dw skoh_action_smlbp, data_pal_allblack
						dw skoh_keyframer_action_wait, 50*13
						
						dw skoh_action_firep, data_pal_allblack
						dw skoh_keyframer_action_wait, 50*5
						
						dw skoh_action_sr_white
						dw skoh_action_ss_pal, data_pal_splitscreen1
						dw skoh_action_ss_wav,&2080,&3400
						dw skoh_action_ss_mov,&0000
						dw skoh_keyframer_action_wait, 50*13
						
						dw skoh_action_firep, skoh_flipscroll_pal4
						dw skoh_keyframer_action_wait, 50*5
						
						dw skoh_keyframer_action_jump, data_keyframer_loop
						
						
skoh_action_sml_mov:		ld de,skoh_var_smlb_mov
						ldi
						ld de,skoh_var_smlt_mov
						ldi
						ret
						
						; ***************
						; *** SML-TOP ***
						; ***************
skoh_action_smltp:			ld de,skoh_var_smlt_pal
						ldi
						ldi
						ret

						; *******************
						; *** SML-BOTTOOM ***
						; *******************
skoh_action_smlbp:			ld de,skoh_var_smlb_pal
						ldi
						ldi
						ret

						; ************
						; *** FIRE ***
						; ************
						
skoh_action_firep:			ld de,skoh_var_fire_pal
						ldi
						ldi
						ret
						
skoh_action_firem:			ld de,skoh_var_fire_mov
						ldi
						ret
						
						
						; ****************
						; *** SCROLLER ***
						; ****************
skoh_action_scroll_stop:
						ld de,skoh_scrollwaster
skoh_action_scroll_poke		ld (skoh_var_scrolltext_call),de
						ret
						
skoh_action_scroll_start:	ld de,skoh_scrolltext
						jr skoh_action_scroll_poke






						; ********************
						; *** SPLIT-RASTER ***
						; ********************

skoh_action_sr_setsin:
						ld de,skoh_var_splitraster_sin0
						ldi
						ldi
						inc de	; ld de,skoh_var_splitraster_sin1
						ldi
						ldi
						inc de	; ld de,skoh_var_splitraster_sin2
						ldi
						ldi
						ret
skoh_action_sr_setmov:
						ld de,skoh_var_splitraster_mov0
						ldi
						ldi
						ldi
						ret

skoh_action_sr_black:
						ld de,&5454
						jr skoh_action_sr_wb
skoh_action_sr_white:
						ld de,&4B4B
skoh_action_sr_wb
						ld a,&01
						ld (skoh_var_splitraster_pen),a
						ld a,d
						ld (skoh_var_splitraster_ink1),a
						ld (skoh_var_splitraster_ink3),de
						ld (skoh_var_splitraster_ink5),de
						ld (skoh_var_splitraster_ink6),a
						ld (skoh_var_splitraster_ink8),de
						ld (skoh_var_splitraster_ink10),de
						ld (skoh_var_splitraster_ink11),a
						ret

skoh_action_sr_paper:
						xor a
skoh_action_sr_setpen		ld (skoh_var_splitraster_pen),a
						ret
skoh_action_sr_pen1:
						ld a,1
						jr skoh_action_sr_setpen
						
						
skoh_action_sr_pal_pink:
						ld a,&54
						ld (skoh_var_splitraster_ink1),a
						ld de,&5845
						ld (skoh_var_splitraster_ink3),de
						ld de,&474F
						ld (skoh_var_splitraster_ink5),de
						ld a,&44
						ld (skoh_var_splitraster_ink6),a
						ld de,&4F47
						ld (skoh_var_splitraster_ink8),de
						ld de,&4558
						ld (skoh_var_splitraster_ink10),de
						ld a,&4B
						ld (skoh_var_splitraster_ink11),a
						ret
						
skoh_action_sr_pal_blue:
						ld a,&54
						ld (skoh_var_splitraster_ink1),a
						ld a,&44
						ld (skoh_var_splitraster_ink6),a
						ld de,&5D5F
						ld (skoh_var_splitraster_ink3),de
						ld de,&534B
						ld (skoh_var_splitraster_ink5),de
						
						ld a,&53
						ld (skoh_var_splitraster_ink11),a
						
						ld de,&5F5D
						ld (skoh_var_splitraster_ink8),de
						ld de,&4454
						ld (skoh_var_splitraster_ink10),de
						ret
						
skoh_action_sr_pal_blue_pink:
						ld a,&54
						ld (skoh_var_splitraster_ink1),a
						ld a,&44
						ld (skoh_var_splitraster_ink6),a
						ld de,&5D5F
						ld (skoh_var_splitraster_ink3),de
						ld de,&535B
						ld (skoh_var_splitraster_ink5),de

						ld a,&4B
						ld (skoh_var_splitraster_ink11),a
						
						ld de,&4F47
						ld (skoh_var_splitraster_ink8),de
						ld de,&4558
						ld (skoh_var_splitraster_ink10),de
						ret
						
skoh_action_sr_pal_green:
						ld a,&54
						ld (skoh_var_splitraster_ink1),a
						ld a,&54
						ld (skoh_var_splitraster_ink6),a
						ld de,&565E
						ld (skoh_var_splitraster_ink3),de
						ld de,&5259
						ld (skoh_var_splitraster_ink5),de

						ld a,&4B
						ld (skoh_var_splitraster_ink11),a
						
						ld de,&5952
						ld (skoh_var_splitraster_ink8),de
						ld de,&5E56
						ld (skoh_var_splitraster_ink10),de
						ret

skoh_action_sr_pal_red:
						ld a,&54
						ld (skoh_var_splitraster_ink1),a
						ld a,&5C
						ld (skoh_var_splitraster_ink6),a
						ld de,&4C4E
						ld (skoh_var_splitraster_ink3),de
						ld de,&4A43
						ld (skoh_var_splitraster_ink5),de

						ld a,&4B
						ld (skoh_var_splitraster_ink11),a
						
						ld de,&4A4E
						ld (skoh_var_splitraster_ink8),de
						ld de,&4C5C
						ld (skoh_var_splitraster_ink10),de
						ret


skoh_action_sr_pal_blurp:
						ld a,&5C
						ld (skoh_var_splitraster_ink1),a
						ld a,&58
						ld (skoh_var_splitraster_ink6),a
						ld de,&565E
						ld (skoh_var_splitraster_ink3),de
						ld de,&4743
						ld (skoh_var_splitraster_ink5),de

						ld a,&4B
						ld (skoh_var_splitraster_ink11),a
						
						ld de,&434A
						ld (skoh_var_splitraster_ink8),de
						ld de,&4E4C
						ld (skoh_var_splitraster_ink10),de
						ret
						
skoh_action_sr_pal_red_blue:
						ld a,&54
						ld (skoh_var_splitraster_ink1),a
						ld a,&5C
						ld (skoh_var_splitraster_ink6),a
						ld de,&4C4E
						ld (skoh_var_splitraster_ink3),de
						ld de,&4A4B
						ld (skoh_var_splitraster_ink5),de

						ld a,&5B
						ld (skoh_var_splitraster_ink11),a
						
						ld de,&535F
						ld (skoh_var_splitraster_ink8),de
						ld de,&5D44
						ld (skoh_var_splitraster_ink10),de
						ret


						; ********************
						; *** SPLIT-SCREEN ***
						; ********************
skoh_action_ss_mov:
						ld de,skoh_var_splitscreen_sin1_stp
						ldi
						ldi
						ret
skoh_action_ss_wav:
						ld de,skoh_var_splitscreen_sin0_pos
						ldi
						ldi
						ld de,skoh_var_splitscreen_sin1_pos
						ldi
						ldi
						ret
skoh_action_ss_pal:
						ld de,skoh_var_pal_splitscreen
						ldi
						ldi
						ret
						
						
						
						
						; Palettes for SML paralax scrollers and Fire animation
skoh_flipscroll_pal1		db &4B,&5A,&56	; 26,21,9 - vert
skoh_flipscroll_pal2		db &4B,&5F,&5D	; 26,14,5 - bleu/mauve
skoh_flipscroll_pal3		db &4B,&57,&55	; 26,11,2 - bleu
skoh_flipscroll_pal4		db &4B,&4E,&4C	; 26,15,6 - rouge/blanc
skoh_flipscroll_pal5		db &4B,&5F,&46	; 26,14,10 - bleu/gris
skoh_flipscroll_pal6		db &43,&47,&58	; 25,16,4 - rainbird/aks
skoh_flipscroll_pal7		db &4B,&53,&40 ; 26,20,13 - gris/bleu froid
skoh_flipscroll_pal8		db &4E,&4C,&5C	; 15,6,3 - rouge sombre
skoh_flipscroll_pal9		db &43,&5E,&5C ; 25,12,3 - rouge/vert
skoh_flipscroll_pal10		db &43,&4E,&4C ; 25,15,6 - rouge/jaune
skoh_flipscroll_pal11		db &53,&5F,&58	; 20,14,4
skoh_flipscroll_pal12		db &5F,&5D,&58	; 20,14,4
skoh_flipscroll_pal13		db &43,&4F,&58	; 25,16,4
skoh_flipscroll_pal14		db &57,&55,&44	; 11,2,1
skoh_flipscroll_pal15		db &5A,&52,&56	; 21,18,9
						
data_pal_splitscreen1		db &40,&47,&5C,&4C,&4E,&4A,&56,&42,&53,&57,&44,&55,&4F,&58, &4B,&54
						
data_pal_allblack			ds 16,&54
						


						; Note; could have been much shorter and simple to do it with OUTI
						; but I did 4us rasters at first and then changed my mind =)

						; A,C,H,L,D,E,/,C',H',L',D',E',/,
						
skoh_splitraster_p0			; [64us]
						; pre-synchro
						ds 7,0
						; [52us] hard-coded plasma texture
						out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:exx
						; post-synchro
						ds 2,0
						ret
						
skoh_splitraster_p1			; [64us]
						; pre-synchro
						ds 6,0
						; [52us] hard-coded plasma texture
						out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:exx
						; post-synchro
						ds 3,0
						ret
						
skoh_splitraster_p2			; [64us]
						; pre-synchro
						ds 5,0
						; [52us] hard-coded plasma texture
						out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:exx
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p3			; [64us]
						; pre-synchro
						ds 4,0
						; [52us] hard-coded plasma texture
						out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:exx
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p4			; [64us]
						; pre-synchro
						ds 3,0
						; [52us] hard-coded plasma texture
						out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:exx
						; post-synchro
						ds 0,0
						ret
						
						
						
						
skoh_splitraster_p5			; [64us]
						; pre-synchro
						ds 7,0
						; [53us] hard-coded plasma texture
						out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:exx
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p6			; [64us]
						; pre-synchro
						ds 6,0
						; [53us] hard-coded plasma texture
						out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:exx
						; post-synchro
						ds 2,0
						ret
						
skoh_splitraster_p7			; [64us]
						; pre-synchro
						ds 5,0
						; [53us] hard-coded plasma texture
						out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:exx
						; post-synchro
						ds 3,0
						ret
						
						
skoh_splitraster_p8			; [64us]
						; pre-synchro
						ds 4,0
						; [53us] hard-coded plasma texture
						out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:exx
						; post-synchro
						ds 4,0
						ret
						
						
skoh_splitraster_p9			; [64us]
						; pre-synchro
						ds 3,0
						; [53us] hard-coded plasma texture
						out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:exx
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p10		; [64us]
						; pre-synchro
						ds 2,0
						; [53us] hard-coded plasma texture
						out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx
						; post-synchro
						ds 0,0
						ret
						
						
						
						
						
skoh_splitraster_p11		; [64us]
						; pre-synchro
						ds 7,0
						; [53us] hard-coded plasma texture
						out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p12		; [64us]
						; pre-synchro
						ds 6,0
						; [53us] hard-coded plasma texture
						out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx
						; post-synchro
						ds 2,0
						ret

skoh_splitraster_p13		; [64us]
						; pre-synchro
						ds 5,0
						; [53us] hard-coded plasma texture
						out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx
						; post-synchro
						ds 3,0
						ret
						
skoh_splitraster_p14		; [64us]
						; pre-synchro
						ds 4,0
						; [53us] hard-coded plasma texture
						out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p15		; [64us]
						; pre-synchro
						ds 3,0
						; [57us] hard-coded plasma texture
						out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p16		; [64us]
						; pre-synchro
						ds 2,0
						; [57us] hard-coded plasma texture
						out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a
						; post-synchro
						ds 2,0
						ret
						
						
						
						
skoh_splitraster_p17		; [64us]
						; pre-synchro
						ds 7,0
						; [51us] hard-coded plasma texture
						out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a
						; post-synchro
						ds 3,0
						ret
						
skoh_splitraster_p18		; [64us]
						; pre-synchro
						ds 6,0
						; [57us] hard-coded plasma texture
						out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p19		; [64us]
						; pre-synchro
						ds 5,0
						; [57us] hard-coded plasma texture
						out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p20		; [64us]
						; pre-synchro
						ds 4,0
						; [57us] hard-coded plasma texture
						out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p21		; [64us]
						; pre-synchro
						ds 3,0
						; [57us] hard-coded plasma texture
						out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c
						; post-synchro
						ds 2,0
						ret
						
skoh_splitraster_p22		; [64us]
						; pre-synchro
						ds 2,0
						; [57us] hard-coded plasma texture
						out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c
						; post-synchro
						ds 3,0
						ret
						
						
						
						
skoh_splitraster_p23		; [64us]
						; pre-synchro
						ds 7,0
						; [50us] hard-coded plasma texture
						out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p24		; [64us]
						; pre-synchro
						ds 6,0
						; [50us] hard-coded plasma texture
						out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p25		; [64us]
						; pre-synchro
						ds 5,0
						; [50us] hard-coded plasma texture
						out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c
						; post-synchro
						ds 6,0
						ret
						
skoh_splitraster_p26		; [64us]
						; pre-synchro
						ds 4,0
						; [50us] hard-coded plasma texture
						out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p27		; [64us]
						; pre-synchro
						ds 3,0
						; [50us] hard-coded plasma texture
						out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h
						; post-synchro
						ds 2,0
						ret
						
skoh_splitraster_p28		; [64us]
						; pre-synchro
						ds 2,0
						; [50us] hard-coded plasma texture
						out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h
						; post-synchro
						ds 3,0
						ret
						
						
						
						
skoh_splitraster_p29		; [64us]
						; pre-synchro
						ds 7,0
						; [50us] hard-coded plasma texture
						out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p30		; [64us]
						; pre-synchro
						ds 6,0
						; [50us] hard-coded plasma texture
						out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p31		; [64us]
						; pre-synchro
						ds 5,0
						; [50us] hard-coded plasma texture
						out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h
						; post-synchro
						ds 6,0
						ret
						
skoh_splitraster_p32		; [64us]
						; pre-synchro
						ds 4,0
						; [50us] hard-coded plasma texture
						out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p33		; [64us]
						; pre-synchro
						ds 3,0
						; [50us] hard-coded plasma texture
						out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l
						; post-synchro
						ds 2,0
						ret
						
skoh_splitraster_p34		; [64us]
						; pre-synchro
						ds 2,0
						; [50us] hard-coded plasma texture
						out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l
						; post-synchro
						ds 3,0
						ret
						
						
						
						
						
						
skoh_splitraster_p35		; [64us]
						; pre-synchro
						ds 6,0
						; [50us] hard-coded plasma texture
						exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p36		; [64us]
						; pre-synchro
						ds 5,0
						; [50us] hard-coded plasma texture
						exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p37		; [64us]
						; pre-synchro
						ds 4,0
						; [50us] hard-coded plasma texture
						exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l
						; post-synchro
						ds 6,0
						ret
						
skoh_splitraster_p38		; [64us]
						; pre-synchro
						ds 3,0
						; [50us] hard-coded plasma texture
						exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p39		; [64us]
						; pre-synchro
						ds 2,0
						; [50us] hard-coded plasma texture
						exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d
						; post-synchro
						ds 2,0
						ret
						
skoh_splitraster_p40		; [64us]
						; pre-synchro
						ds 1,0
						; [50us] hard-coded plasma texture
						exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d
						; post-synchro
						ds 3,0
						ret
						
						
						
						
skoh_splitraster_p41		; [64us]
						; pre-synchro
						ds 6,0
						; [50us] hard-coded plasma texture
						exx:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p42		; [64us]
						; pre-synchro
						ds 5,0
						; [50us] hard-coded plasma texture
						exx:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p43		; [64us]
						; pre-synchro
						ds 4,0
						; [50us] hard-coded plasma texture
						exx:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d
						; post-synchro
						ds 6,0
						ret
						
skoh_splitraster_p44		; [64us]
						; pre-synchro
						ds 3,0
						; [50us] hard-coded plasma texture
						exx:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p45		; [64us]
						; pre-synchro
						ds 2,0
						; [50us] hard-coded plasma texture
						exx:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e
						; post-synchro
						ds 2,0
						ret
						
skoh_splitraster_p46		; [64us]
						; pre-synchro
						ds 1,0
						; [50us] hard-coded plasma texture
						exx:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e
						; post-synchro
						ds 3,0
						ret
						
						
						
						
						
skoh_splitraster_p47		; [64us]
						; pre-synchro
						ds 6,0
						; [50us] hard-coded plasma texture
						exx:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p48		; [64us]
						; pre-synchro
						ds 5,0
						; [50us] hard-coded plasma texture
						exx:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p49		; [64us]
						; pre-synchro
						ds 4,0
						; [50us] hard-coded plasma texture
						exx:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e
						; post-synchro
						ds 6,0
						ret
						
skoh_splitraster_p50		; [64us]
						; pre-synchro
						ds 3,0
						; [50us] hard-coded plasma texture
						exx:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:exx
						; post-synchro
						ds 0,0
						ret
						
skoh_splitraster_p51		; [64us]
						; pre-synchro
						ds 2,0
						; [50us] hard-coded plasma texture
						exx:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:exx
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p52		; [64us]
						; pre-synchro
						ds 1,0
						; [50us] hard-coded plasma texture
						exx:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:exx
						; post-synchro
						ds 2,0
						ret
						
						
						
						
						
						
skoh_splitraster_p53		; [64us]
						; pre-synchro
						ds 6,0
						; [50us] hard-coded plasma texture
						exx:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:exx
						; post-synchro
						ds 3,0
						ret
						
skoh_splitraster_p54		; [64us]
						; pre-synchro
						ds 5,0
						; [50us] hard-coded plasma texture
						exx:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:exx
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p55		; [64us]
						; pre-synchro
						ds 4,0
						; [50us] hard-coded plasma texture
						exx:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:exx
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p56		; [64us]
						; pre-synchro
						ds 3,0
						; [50us] hard-coded plasma texture
						exx:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:exx
						; post-synchro
						ds 0,0
						ret
						
skoh_splitraster_p57		; [64us]
						; pre-synchro
						ds 2,0
						; [50us] hard-coded plasma texture
						exx:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:exx
						; post-synchro
						ds 1,0
						ret
						
skoh_splitraster_p58		; [64us]
						; pre-synchro
						ds 1,0
						; [50us] hard-coded plasma texture
						exx:out (c),d:nop:nop:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:exx
						; post-synchro
						ds 2,0
						ret
						
						
						
						
						
						
skoh_splitraster_p59		; [64us]
						; pre-synchro
						ds 6,0
						; [50us] hard-coded plasma texture
						exx:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:exx
						; post-synchro
						ds 3,0
						ret
						
skoh_splitraster_p60		; [64us]
						; pre-synchro
						ds 5,0
						; [50us] hard-coded plasma texture
						exx:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:exx
						; post-synchro
						ds 4,0
						ret
						
skoh_splitraster_p61		; [64us]
						; pre-synchro
						ds 4,0
						; [50us] hard-coded plasma texture
						exx:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:exx
						; post-synchro
						ds 5,0
						ret
						
skoh_splitraster_p62		; [64us]
						; pre-synchro
						ds 3,0
						; [50us] hard-coded plasma texture
						exx:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:exx
						; post-synchro
						ds 0,0
						ret
						
skoh_splitraster_p63		; [64us]
						; pre-synchro
						ds 2,0
						; [50us] hard-coded plasma texture
						exx:out (c),e:exx:out (c),a:nop:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:nop:nop:out (c),d:nop:nop:out (c),e:nop:exx:out (c),c:nop:nop:out (c),h:nop:nop:out (c),l:exx
						; post-synchro
						ds 1,0
						ret

						dw skoh_splitraster_p0,skoh_splitraster_p1
skoh_splitraster_ret
						dw skoh_splitraster_p2,skoh_splitraster_p3
						dw skoh_splitraster_p4,skoh_splitraster_p5,skoh_splitraster_p6,skoh_splitraster_p7
						dw skoh_splitraster_p8,skoh_splitraster_p9,skoh_splitraster_p10,skoh_splitraster_p11
						dw skoh_splitraster_p12,skoh_splitraster_p13,skoh_splitraster_p14,skoh_splitraster_p15
						dw skoh_splitraster_p16,skoh_splitraster_p17,skoh_splitraster_p18,skoh_splitraster_p19
						dw skoh_splitraster_p20,skoh_splitraster_p21,skoh_splitraster_p22,skoh_splitraster_p23
						dw skoh_splitraster_p24,skoh_splitraster_p25,skoh_splitraster_p26,skoh_splitraster_p27
						dw skoh_splitraster_p28,skoh_splitraster_p29,skoh_splitraster_p30,skoh_splitraster_p31
						dw skoh_splitraster_p32,skoh_splitraster_p33,skoh_splitraster_p34,skoh_splitraster_p35
						dw skoh_splitraster_p36,skoh_splitraster_p37,skoh_splitraster_p38,skoh_splitraster_p39
						dw skoh_splitraster_p40,skoh_splitraster_p41,skoh_splitraster_p42,skoh_splitraster_p43
						dw skoh_splitraster_p44,skoh_splitraster_p45,skoh_splitraster_p46,skoh_splitraster_p47
						dw skoh_splitraster_p48,skoh_splitraster_p49,skoh_splitraster_p50,skoh_splitraster_p51
						dw skoh_splitraster_p52,skoh_splitraster_p53,skoh_splitraster_p54,skoh_splitraster_p55
						dw skoh_splitraster_p56,skoh_splitraster_p57,skoh_splitraster_p58,skoh_splitraster_p59
						dw skoh_splitraster_p60,skoh_splitraster_p61,skoh_splitraster_p62,skoh_splitraster_p63
skoh_splitraster_push		dw skoh_splitraster_exit

						align 256
skoh_splitraster_lut		ds 4,skoh_splitraster_p0 and 255
						ds 4,skoh_splitraster_p1 and 255
						ds 4,skoh_splitraster_p2 and 255
						ds 4,skoh_splitraster_p3 and 255
						ds 4,skoh_splitraster_p4 and 255
						ds 4,skoh_splitraster_p5 and 255
						ds 4,skoh_splitraster_p6 and 255
						ds 4,skoh_splitraster_p7 and 255
						ds 4,skoh_splitraster_p8 and 255
						ds 4,skoh_splitraster_p9 and 255
						ds 4,skoh_splitraster_p10 and 255
						ds 4,skoh_splitraster_p11 and 255
						ds 4,skoh_splitraster_p12 and 255
						ds 4,skoh_splitraster_p13 and 255
						ds 4,skoh_splitraster_p14 and 255
						ds 4,skoh_splitraster_p15 and 255
						ds 4,skoh_splitraster_p16 and 255
						ds 4,skoh_splitraster_p17 and 255
						ds 4,skoh_splitraster_p18 and 255
						ds 4,skoh_splitraster_p19 and 255
						ds 4,skoh_splitraster_p20 and 255
						ds 4,skoh_splitraster_p21 and 255
						ds 4,skoh_splitraster_p22 and 255
						ds 4,skoh_splitraster_p23 and 255
						ds 4,skoh_splitraster_p24 and 255
						ds 4,skoh_splitraster_p25 and 255
						ds 4,skoh_splitraster_p26 and 255
						ds 4,skoh_splitraster_p27 and 255
						ds 4,skoh_splitraster_p28 and 255
						ds 4,skoh_splitraster_p29 and 255
						ds 4,skoh_splitraster_p30 and 255
						ds 4,skoh_splitraster_p31 and 255
						ds 4,skoh_splitraster_p32 and 255
						ds 4,skoh_splitraster_p33 and 255
						ds 4,skoh_splitraster_p34 and 255
						ds 4,skoh_splitraster_p35 and 255
						ds 4,skoh_splitraster_p36 and 255
						ds 4,skoh_splitraster_p37 and 255
						ds 4,skoh_splitraster_p38 and 255
						ds 4,skoh_splitraster_p39 and 255
						ds 4,skoh_splitraster_p40 and 255
						ds 4,skoh_splitraster_p41 and 255
						ds 4,skoh_splitraster_p42 and 255
						ds 4,skoh_splitraster_p43 and 255
						ds 4,skoh_splitraster_p44 and 255
						ds 4,skoh_splitraster_p45 and 255
						ds 4,skoh_splitraster_p46 and 255
						ds 4,skoh_splitraster_p47 and 255
						ds 4,skoh_splitraster_p48 and 255
						ds 4,skoh_splitraster_p49 and 255
						ds 4,skoh_splitraster_p50 and 255
						ds 4,skoh_splitraster_p51 and 255
						ds 4,skoh_splitraster_p52 and 255
						ds 4,skoh_splitraster_p53 and 255
						ds 4,skoh_splitraster_p54 and 255
						ds 4,skoh_splitraster_p55 and 255
						ds 4,skoh_splitraster_p56 and 255
						ds 4,skoh_splitraster_p57 and 255
						ds 4,skoh_splitraster_p58 and 255
						ds 4,skoh_splitraster_p59 and 255
						ds 4,skoh_splitraster_p60 and 255
						ds 4,skoh_splitraster_p61 and 255
						ds 4,skoh_splitraster_p62 and 255
						ds 4,skoh_splitraster_p63 and 255
						
						
						ds 4,skoh_splitraster_p0/256
						ds 4,skoh_splitraster_p1/256
						ds 4,skoh_splitraster_p2/256
						ds 4,skoh_splitraster_p3/256
						ds 4,skoh_splitraster_p4/256
						ds 4,skoh_splitraster_p5/256
						ds 4,skoh_splitraster_p6/256
						ds 4,skoh_splitraster_p7/256
						ds 4,skoh_splitraster_p8/256
						ds 4,skoh_splitraster_p9/256
						ds 4,skoh_splitraster_p10/256
						ds 4,skoh_splitraster_p11/256
						ds 4,skoh_splitraster_p12/256
						ds 4,skoh_splitraster_p13/256
						ds 4,skoh_splitraster_p14/256
						ds 4,skoh_splitraster_p15/256
						ds 4,skoh_splitraster_p16/256
						ds 4,skoh_splitraster_p17/256
						ds 4,skoh_splitraster_p18/256
						ds 4,skoh_splitraster_p19/256
						ds 4,skoh_splitraster_p20/256
						ds 4,skoh_splitraster_p21/256
						ds 4,skoh_splitraster_p22/256
						ds 4,skoh_splitraster_p23/256
						ds 4,skoh_splitraster_p24/256
						ds 4,skoh_splitraster_p25/256
						ds 4,skoh_splitraster_p26/256
						ds 4,skoh_splitraster_p27/256
						ds 4,skoh_splitraster_p28/256
						ds 4,skoh_splitraster_p29/256
						ds 4,skoh_splitraster_p30/256
						ds 4,skoh_splitraster_p31/256
						ds 4,skoh_splitraster_p32/256
						ds 4,skoh_splitraster_p33/256
						ds 4,skoh_splitraster_p34/256
						ds 4,skoh_splitraster_p35/256
						ds 4,skoh_splitraster_p36/256
						ds 4,skoh_splitraster_p37/256
						ds 4,skoh_splitraster_p38/256
						ds 4,skoh_splitraster_p39/256
						ds 4,skoh_splitraster_p40/256
						ds 4,skoh_splitraster_p41/256
						ds 4,skoh_splitraster_p42/256
						ds 4,skoh_splitraster_p43/256
						ds 4,skoh_splitraster_p44/256
						ds 4,skoh_splitraster_p45/256
						ds 4,skoh_splitraster_p46/256
						ds 4,skoh_splitraster_p47/256
						ds 4,skoh_splitraster_p48/256
						ds 4,skoh_splitraster_p49/256
						ds 4,skoh_splitraster_p50/256
						ds 4,skoh_splitraster_p51/256
						ds 4,skoh_splitraster_p52/256
						ds 4,skoh_splitraster_p53/256
						ds 4,skoh_splitraster_p54/256
						ds 4,skoh_splitraster_p55/256
						ds 4,skoh_splitraster_p56/256
						ds 4,skoh_splitraster_p57/256
						ds 4,skoh_splitraster_p58/256
						ds 4,skoh_splitraster_p59/256
						ds 4,skoh_splitraster_p60/256
						ds 4,skoh_splitraster_p61/256
						ds 4,skoh_splitraster_p62/256
						ds 4,skoh_splitraster_p63/256
						
data_splitscreen_lut
						ds 512,&20
						
						
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************

						
						org &4000
						; jumper
						ld b,&7F
						out (c),c
						jp (hl)

						; hardware scroller
						;  byte-width scrolling speed
						;  64 pixels height
						;  byte-proportionnal char width
skoh_scrolltext:

						; update and flip vram pointers
						ld bc,&0000+120
skoh_var_scrolltext_vram1	equ $-2
						ld de,&0400+119
skoh_var_scrolltext_vram2	equ $-2

						inc bc
						res 3,b
						inc de
						res 3,d

						ld (skoh_var_scrolltext_vram1),de
						ld (skoh_var_scrolltext_vram2),bc
						
						ld hl,-120
						add hl,bc
						ld a,h
						and 7
						rra
						ld h,a
						rr l
						ld (skoh_var_scrolltext_offset),hl
						ld h,b
						ld l,c

						ld (skoh_var_scrolltext_sp),sp
						
						ld bc,&7FC5
						out (c),c

						; display char row
						; 000 line 0
						; 001 line 1 / set 3,h
						; 011 line 3 / set 4,h
						; 010 line 2 / res 3,h
						; 110 line 6 / set 5,h
						; 100 line 4 / res 4,h
						; 101 line 5 / set 3,h
						; 111 line 7 / set 4,h
						
						ld sp,0
skoh_var_scrolltext_chrdat	equ $-2
						xor a
skoh_scrolltext_charplot
						ld (hl),a:set 3,h:ld (hl),a:set 4,h
						ex de,hl
						ld (hl),a:set 3,h:ld (hl),a:set 4,h
						
						ld (hl),a:res 3,h:ld (hl),a:set 5,h
						ex de,hl
						ld (hl),a:res 3,h:ld (hl),a:set 5,h
						
						ld (hl),a:res 4,h:ld (hl),a:set 3,h
						ex de,hl
						ld (hl),a:res 4,h:ld (hl),a:set 3,h
						
						ld (hl),a:set 4,h:ld (hl),a
						ex de,hl
						ld (hl),a:set 4,h:ld (hl),a
						
						; move on the next 8 lines
						ld bc,63*2-&3800
						add hl,bc
						res 3,h
						ex de,hl
						add hl,bc
						res 3,h
						
						pop bc
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						ex de,hl
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						
						pop bc
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						ex de,hl
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						
						pop bc
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						ex de,hl
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						
						pop bc
						ld (hl),c:set 4,h:ld (hl),b
						ex de,hl
						ld (hl),c:set 4,h:ld (hl),b
						
						; move on the next 8 lines
						ld bc,63*2-&3800
						add hl,bc
						res 3,h
						ex de,hl
						add hl,bc
						res 3,h
						
						pop bc
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						ex de,hl
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						
						pop bc
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						ex de,hl
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						
						pop bc
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						ex de,hl
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						
						pop bc
						ld (hl),c:set 4,h:ld (hl),b
						ex de,hl
						ld (hl),c:set 4,h:ld (hl),b
						
						; move on the next 8 lines
						ld bc,63*2-&3800
						add hl,bc
						res 3,h
						ex de,hl
						add hl,bc
						res 3,h
						
						pop bc
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						ex de,hl
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						
						pop bc
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						ex de,hl
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						
						pop bc
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						ex de,hl
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						
						pop bc
						ld (hl),c:set 4,h:ld (hl),b
						ex de,hl
						ld (hl),c:set 4,h:ld (hl),b
						
						; move on the next 8 lines
						ld bc,63*2-&3800
						add hl,bc
						res 3,h
						ex de,hl
						add hl,bc
						res 3,h
						
						pop bc
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						ex de,hl
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						
						pop bc
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						ex de,hl
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						
						pop bc
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						ex de,hl
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						
						pop bc
						ld (hl),c:set 4,h:ld (hl),b
						ex de,hl
						ld (hl),c:set 4,h:ld (hl),b
						
						; move on the next 8 lines
						ld bc,63*2-&3800
						add hl,bc
						res 3,h
						ex de,hl
						add hl,bc
						res 3,h
						
						pop bc
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						ex de,hl
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						
						pop bc
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						ex de,hl
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						
						pop bc
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						ex de,hl
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						
						pop bc
						ld (hl),c:set 4,h:ld (hl),b
						ex de,hl
						ld (hl),c:set 4,h:ld (hl),b
						
						; move on the next 8 lines
						ld bc,63*2-&3800
						add hl,bc
						res 3,h
						ex de,hl
						add hl,bc
						res 3,h
						
						pop bc
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						ex de,hl
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						
						pop bc
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						ex de,hl
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						
						pop bc
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						ex de,hl
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						
						pop bc
						ld (hl),c:set 4,h:ld (hl),b
						ex de,hl
						ld (hl),c:set 4,h:ld (hl),b
						
						; move on the next 8 lines
						ld bc,63*2-&3800
						add hl,bc
						res 3,h
						ex de,hl
						add hl,bc
						res 3,h
						
						pop bc
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						ex de,hl
						ld (hl),c:set 3,h:ld (hl),b:set 4,h
						
						pop bc
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						ex de,hl
						ld (hl),c:res 3,h:ld (hl),b:set 5,h
						
						pop bc
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						ex de,hl
						ld (hl),c:res 4,h:ld (hl),b:set 3,h
						
						pop bc
						ld (hl),c:set 4,h:ld (hl),a
						ex de,hl
						ld (hl),c:set 4,h:ld (hl),a
						
						ld bc,&7FC2
						out (c),c

						; char-row counter
						ld a,1
skoh_var_scrolltext_rowctr	equ $-1
						dec a
						jr z,skoh_scrolltext_nextchr
						; save current data-row pointer
						ld (skoh_var_scrolltext_chrdat),sp
						jr skoh_scrolltext_exit
skoh_scrolltext_nextchr
						; get next char from scrolltext
						ld hl,data_scrolltext
skoh_var_scrolltext_nextchr	equ $-2
						ld de,data_scrolltext_loop
						ld a,(hl)
						inc hl
						add a,a	; x2
						jr nc,$+2+1
						ex de,hl
						ld (skoh_var_scrolltext_nextchr),hl
						
						ld h,0
						ld l,a
						add hl,hl	; x4
						ld de,data_scrollfont
						add hl,de
						
						ld e,(hl)
						inc hl
						ld d,(hl)
						ld (skoh_var_scrolltext_chrdat),de
						
						inc hl
						ld a,(hl)
skoh_scrolltext_exit
						ld (skoh_var_scrolltext_rowctr),a
						
						; restore memory mapping and exit
						ld sp,0
skoh_var_scrolltext_sp		equ $-2
						ret
						
						
						
						read "skoh.scrolltext.asm"
skoh_limit
						org &E8C0
						; music player+data
						incbin "C2.E8C0.BIN"
						
